/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-14 15:32:06 UTC)
 * on 2013-08-19 at 20:45:12 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.orkut.model;

/**
 * Model definition for CommunityList.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Orkut API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class CommunityList extends com.google.api.client.json.GenericJson {

  /**
   * List of communities retrieved.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Community> items;

  /**
   * Identifies this resource as a collection of communities. Value: "orkut#communityList"
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * List of communities retrieved.
   * @return value or {@code null} for none
   */
  public java.util.List<Community> getItems() {
    return items;
  }

  /**
   * List of communities retrieved.
   * @param items items or {@code null} for none
   */
  public CommunityList setItems(java.util.List<Community> items) {
    this.items = items;
    return this;
  }

  /**
   * Identifies this resource as a collection of communities. Value: "orkut#communityList"
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Identifies this resource as a collection of communities. Value: "orkut#communityList"
   * @param kind kind or {@code null} for none
   */
  public CommunityList setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  @Override
  public CommunityList set(String fieldName, Object value) {
    return (CommunityList) super.set(fieldName, value);
  }

  @Override
  public CommunityList clone() {
    return (CommunityList) super.clone();
  }

}
