/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-14 15:32:06 UTC)
 * on 2013-08-19 at 20:45:12 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.orkut.model;

/**
 * Model definition for CommunityPoll.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Orkut API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class CommunityPoll extends com.google.api.client.json.GenericJson {

  /**
   * The person who created the poll.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private OrkutAuthorResource author;

  /**
   * The ID of the community.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer communityId;

  /**
   * The date of creation of this poll
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private com.google.api.client.util.DateTime creationTime;

  /**
   * The poll description.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String description;

  /**
   * The ending date of this poll or empty if the poll doesn't have one.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private com.google.api.client.util.DateTime endingTime;

  /**
   * Whether the user has voted on this poll.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean hasVoted;

  /**
   * The poll ID.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String id;

  /**
   * The image representing the poll. Field is omitted if no image exists.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Image image;

  /**
   * Whether the poll is not expired if there is an expiration date. A poll is open (that is, not
   * closed for voting) if it either is not expired or doesn't have an expiration date at all. Note
   * that just because a poll is open, it doesn't mean that the requester can vote on it.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean isClosed;

  /**
   * Whether this poll allows voting for more than one option.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean isMultipleAnswers;

  /**
   * Whether this poll is still opened for voting. A poll is open for voting if it is not closed,
   * the user has not yet voted on it and the user has the permission to do so, which happens if
   * he/she is either a community member or the poll is open for everybody.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean isOpenForVoting;

  /**
   * Whether this poll is restricted for members only. If a poll is open but the user can't vote on
   * it, it's been restricted to members only. This information is important to tell this case apart
   * from the one where the user can't vote simply because the poll is already closed.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean isRestricted;

  /**
   * Whether the user has marked this poll as spam. This only affects the poll for this user, not
   * globally.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean isSpam;

  /**
   * If user has already voted, whether his vote is publicly visible.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean isUsersVotePublic;

  /**
   * Whether non-members of the community can vote on the poll.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean isVotingAllowedForNonMembers;

  /**
   * Identifies this resource as a community poll. Value: "orkut#communityPoll"
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * The date of the last update of this poll.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private com.google.api.client.util.DateTime lastUpdate;

  /**
   * List of resources for the community poll.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<OrkutLinkResource> links;

  static {
    // hack to force ProGuard to consider OrkutLinkResource used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(OrkutLinkResource.class);
  }

  /**
   * List of options of this poll.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<OrkutCommunitypolloptionResource> options;

  static {
    // hack to force ProGuard to consider OrkutCommunitypolloptionResource used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(OrkutCommunitypolloptionResource.class);
  }

  /**
   * The poll question.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String question;

  /**
   * The total number of votes this poll has received.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer totalNumberOfVotes;

  /**
   * List of options the user has voted on, if there are any.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.Integer> votedOptions;

  /**
   * The person who created the poll.
   * @return value or {@code null} for none
   */
  public OrkutAuthorResource getAuthor() {
    return author;
  }

  /**
   * The person who created the poll.
   * @param author author or {@code null} for none
   */
  public CommunityPoll setAuthor(OrkutAuthorResource author) {
    this.author = author;
    return this;
  }

  /**
   * The ID of the community.
   * @return value or {@code null} for none
   */
  public java.lang.Integer getCommunityId() {
    return communityId;
  }

  /**
   * The ID of the community.
   * @param communityId communityId or {@code null} for none
   */
  public CommunityPoll setCommunityId(java.lang.Integer communityId) {
    this.communityId = communityId;
    return this;
  }

  /**
   * The date of creation of this poll
   * @return value or {@code null} for none
   */
  public com.google.api.client.util.DateTime getCreationTime() {
    return creationTime;
  }

  /**
   * The date of creation of this poll
   * @param creationTime creationTime or {@code null} for none
   */
  public CommunityPoll setCreationTime(com.google.api.client.util.DateTime creationTime) {
    this.creationTime = creationTime;
    return this;
  }

  /**
   * The poll description.
   * @return value or {@code null} for none
   */
  public java.lang.String getDescription() {
    return description;
  }

  /**
   * The poll description.
   * @param description description or {@code null} for none
   */
  public CommunityPoll setDescription(java.lang.String description) {
    this.description = description;
    return this;
  }

  /**
   * The ending date of this poll or empty if the poll doesn't have one.
   * @return value or {@code null} for none
   */
  public com.google.api.client.util.DateTime getEndingTime() {
    return endingTime;
  }

  /**
   * The ending date of this poll or empty if the poll doesn't have one.
   * @param endingTime endingTime or {@code null} for none
   */
  public CommunityPoll setEndingTime(com.google.api.client.util.DateTime endingTime) {
    this.endingTime = endingTime;
    return this;
  }

  /**
   * Whether the user has voted on this poll.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getHasVoted() {
    return hasVoted;
  }

  /**
   * Whether the user has voted on this poll.
   * @param hasVoted hasVoted or {@code null} for none
   */
  public CommunityPoll setHasVoted(java.lang.Boolean hasVoted) {
    this.hasVoted = hasVoted;
    return this;
  }

  /**
   * The poll ID.
   * @return value or {@code null} for none
   */
  public java.lang.String getId() {
    return id;
  }

  /**
   * The poll ID.
   * @param id id or {@code null} for none
   */
  public CommunityPoll setId(java.lang.String id) {
    this.id = id;
    return this;
  }

  /**
   * The image representing the poll. Field is omitted if no image exists.
   * @return value or {@code null} for none
   */
  public Image getImage() {
    return image;
  }

  /**
   * The image representing the poll. Field is omitted if no image exists.
   * @param image image or {@code null} for none
   */
  public CommunityPoll setImage(Image image) {
    this.image = image;
    return this;
  }

  /**
   * Whether the poll is not expired if there is an expiration date. A poll is open (that is, not
   * closed for voting) if it either is not expired or doesn't have an expiration date at all. Note
   * that just because a poll is open, it doesn't mean that the requester can vote on it.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getIsClosed() {
    return isClosed;
  }

  /**
   * Whether the poll is not expired if there is an expiration date. A poll is open (that is, not
   * closed for voting) if it either is not expired or doesn't have an expiration date at all. Note
   * that just because a poll is open, it doesn't mean that the requester can vote on it.
   * @param isClosed isClosed or {@code null} for none
   */
  public CommunityPoll setIsClosed(java.lang.Boolean isClosed) {
    this.isClosed = isClosed;
    return this;
  }

  /**
   * Whether this poll allows voting for more than one option.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getIsMultipleAnswers() {
    return isMultipleAnswers;
  }

  /**
   * Whether this poll allows voting for more than one option.
   * @param isMultipleAnswers isMultipleAnswers or {@code null} for none
   */
  public CommunityPoll setIsMultipleAnswers(java.lang.Boolean isMultipleAnswers) {
    this.isMultipleAnswers = isMultipleAnswers;
    return this;
  }

  /**
   * Whether this poll is still opened for voting. A poll is open for voting if it is not closed,
   * the user has not yet voted on it and the user has the permission to do so, which happens if
   * he/she is either a community member or the poll is open for everybody.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getIsOpenForVoting() {
    return isOpenForVoting;
  }

  /**
   * Whether this poll is still opened for voting. A poll is open for voting if it is not closed,
   * the user has not yet voted on it and the user has the permission to do so, which happens if
   * he/she is either a community member or the poll is open for everybody.
   * @param isOpenForVoting isOpenForVoting or {@code null} for none
   */
  public CommunityPoll setIsOpenForVoting(java.lang.Boolean isOpenForVoting) {
    this.isOpenForVoting = isOpenForVoting;
    return this;
  }

  /**
   * Whether this poll is restricted for members only. If a poll is open but the user can't vote on
   * it, it's been restricted to members only. This information is important to tell this case apart
   * from the one where the user can't vote simply because the poll is already closed.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getIsRestricted() {
    return isRestricted;
  }

  /**
   * Whether this poll is restricted for members only. If a poll is open but the user can't vote on
   * it, it's been restricted to members only. This information is important to tell this case apart
   * from the one where the user can't vote simply because the poll is already closed.
   * @param isRestricted isRestricted or {@code null} for none
   */
  public CommunityPoll setIsRestricted(java.lang.Boolean isRestricted) {
    this.isRestricted = isRestricted;
    return this;
  }

  /**
   * Whether the user has marked this poll as spam. This only affects the poll for this user, not
   * globally.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getIsSpam() {
    return isSpam;
  }

  /**
   * Whether the user has marked this poll as spam. This only affects the poll for this user, not
   * globally.
   * @param isSpam isSpam or {@code null} for none
   */
  public CommunityPoll setIsSpam(java.lang.Boolean isSpam) {
    this.isSpam = isSpam;
    return this;
  }

  /**
   * If user has already voted, whether his vote is publicly visible.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getIsUsersVotePublic() {
    return isUsersVotePublic;
  }

  /**
   * If user has already voted, whether his vote is publicly visible.
   * @param isUsersVotePublic isUsersVotePublic or {@code null} for none
   */
  public CommunityPoll setIsUsersVotePublic(java.lang.Boolean isUsersVotePublic) {
    this.isUsersVotePublic = isUsersVotePublic;
    return this;
  }

  /**
   * Whether non-members of the community can vote on the poll.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getIsVotingAllowedForNonMembers() {
    return isVotingAllowedForNonMembers;
  }

  /**
   * Whether non-members of the community can vote on the poll.
   * @param isVotingAllowedForNonMembers isVotingAllowedForNonMembers or {@code null} for none
   */
  public CommunityPoll setIsVotingAllowedForNonMembers(java.lang.Boolean isVotingAllowedForNonMembers) {
    this.isVotingAllowedForNonMembers = isVotingAllowedForNonMembers;
    return this;
  }

  /**
   * Identifies this resource as a community poll. Value: "orkut#communityPoll"
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Identifies this resource as a community poll. Value: "orkut#communityPoll"
   * @param kind kind or {@code null} for none
   */
  public CommunityPoll setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The date of the last update of this poll.
   * @return value or {@code null} for none
   */
  public com.google.api.client.util.DateTime getLastUpdate() {
    return lastUpdate;
  }

  /**
   * The date of the last update of this poll.
   * @param lastUpdate lastUpdate or {@code null} for none
   */
  public CommunityPoll setLastUpdate(com.google.api.client.util.DateTime lastUpdate) {
    this.lastUpdate = lastUpdate;
    return this;
  }

  /**
   * List of resources for the community poll.
   * @return value or {@code null} for none
   */
  public java.util.List<OrkutLinkResource> getLinks() {
    return links;
  }

  /**
   * List of resources for the community poll.
   * @param links links or {@code null} for none
   */
  public CommunityPoll setLinks(java.util.List<OrkutLinkResource> links) {
    this.links = links;
    return this;
  }

  /**
   * List of options of this poll.
   * @return value or {@code null} for none
   */
  public java.util.List<OrkutCommunitypolloptionResource> getOptions() {
    return options;
  }

  /**
   * List of options of this poll.
   * @param options options or {@code null} for none
   */
  public CommunityPoll setOptions(java.util.List<OrkutCommunitypolloptionResource> options) {
    this.options = options;
    return this;
  }

  /**
   * The poll question.
   * @return value or {@code null} for none
   */
  public java.lang.String getQuestion() {
    return question;
  }

  /**
   * The poll question.
   * @param question question or {@code null} for none
   */
  public CommunityPoll setQuestion(java.lang.String question) {
    this.question = question;
    return this;
  }

  /**
   * The total number of votes this poll has received.
   * @return value or {@code null} for none
   */
  public java.lang.Integer getTotalNumberOfVotes() {
    return totalNumberOfVotes;
  }

  /**
   * The total number of votes this poll has received.
   * @param totalNumberOfVotes totalNumberOfVotes or {@code null} for none
   */
  public CommunityPoll setTotalNumberOfVotes(java.lang.Integer totalNumberOfVotes) {
    this.totalNumberOfVotes = totalNumberOfVotes;
    return this;
  }

  /**
   * List of options the user has voted on, if there are any.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.Integer> getVotedOptions() {
    return votedOptions;
  }

  /**
   * List of options the user has voted on, if there are any.
   * @param votedOptions votedOptions or {@code null} for none
   */
  public CommunityPoll setVotedOptions(java.util.List<java.lang.Integer> votedOptions) {
    this.votedOptions = votedOptions;
    return this;
  }

  @Override
  public CommunityPoll set(String fieldName, Object value) {
    return (CommunityPoll) super.set(fieldName, value);
  }

  @Override
  public CommunityPoll clone() {
    return (CommunityPoll) super.clone();
  }

  /**
   * The image representing the poll. Field is omitted if no image exists.
   */
  public static final class Image extends com.google.api.client.json.GenericJson {

    /**
     * A URL that points to an image of the poll.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String url;

    /**
     * A URL that points to an image of the poll.
     * @return value or {@code null} for none
     */
    public java.lang.String getUrl() {
      return url;
    }

    /**
     * A URL that points to an image of the poll.
     * @param url url or {@code null} for none
     */
    public Image setUrl(java.lang.String url) {
      this.url = url;
      return this;
    }

    @Override
    public Image set(String fieldName, Object value) {
      return (Image) super.set(fieldName, value);
    }

    @Override
    public Image clone() {
      return (Image) super.clone();
    }

  }

}
